/*
#include <stddef.h>
*/

#ifndef	RL_T
#define RL_T	char
#endif

static void	RangeList(char *rl,size_t lim,RL_T *lut,RL_T val)
{
	char	c,*brl="bad range list.";
	size_t	low,upp,idx;

#define GETC()	(*(rl++))
#define STOI(I)	for (I=0; c>='0' && c<='9'; c=GETC()) \
		    if ((I=I*10+c-'0')>lim) Error(brl)

	do {
	    while ((c=GETC())==',') ;

	    if (c!='\0') {
		if (c=='-') {
		    low=0;
		    if ((c=GETC())==',' || c=='\0')
			upp=lim;
		    else {
			STOI(upp);
			if (c!=',' && c!='\0') Error(brl);
		    }
		}
		else {
		    STOI(low);
		    if (c==',' || c=='\0')
			upp=low;
		    else if (c=='-')
			if ((c=GETC())==',' || c=='\0')
			    upp=lim;
			else {
			    STOI(upp);
			    if ((c!=',' && c!='\0') || upp<low) Error(brl);
			}
		    else
			Error(brl);
		}
		for (idx=low; idx<=upp; idx++) lut[idx]=val;
	    }
	} while (c==',');
}
